# This is makefile transformed from Borland makefile to GNU makefile format
# Borland C++ Builder Project can be built under Eclipse.
#
# In order to read description: "How to build C++ Builder project in Eclipse using GNU make" please refer to:
# English:   http://www.elesoftrom.com.pl/blog/en/cbuilder_eclipse_gnumake.php
# po polsku: http://www.elesoftrom.com.pl/blog/pl/cbuilder_eclipse_gnumake.php 
# ---------------------------------------------------------------------------
# Path used in arguments list when calling Borland tools
BCB_ROOT=c:\PROGRA~1\Borland\Cbuilder6

# Path to Borland tools for shell (MSYS) that is used by make
BCB_BIN=/c/PROGRA~1/Borland/Cbuilder6/bin

# Path to MSYS tools
MSYS_BIN=/c/mingw/msys/1.0/bin

# Path to MinGW
MINGW_BIN=/c/MinGW/bin

# ---------------------------------------------------------------------------
# IDE SECTION
# ---------------------------------------------------------------------------
# The following section of the project makefile is managed by the BCB IDE.
# It is recommended to use the IDE to change any of the values in this
# section.
# ---------------------------------------------------------------------------

VERSION = BCB.06.00
# ---------------------------------------------------------------------------

# folders for intermediate and target files:
BUILD_PREFIX=build
EXE_PREFIX=_stage

# project name
PROJECT = hello1

EXE_FILE = $(PROJECT).exe
MAP_FILE = $(PROJECT).map

# list of modules
OBJS = hello1.obj Unit1.obj

# NOTE DO NOT delete hello1.res file it is generated by IDE (no .rc source is available)
RESFILES = hello1.res
MAINSOURCE = hello1.cpp
RESDEPEN = $(RESFILES) Unit1.dfm
LIBFILES = 
IDLFILES = 
IDLGENFILES = 
LIBRARIES = vcl.lib rtl.lib vclx.lib
PACKAGES = vcl.bpi rtl.bpi
SPARELIBS = vcl.lib rtl.lib vclx.lib
DEFFILE = 
OTHERFILES = 
# ---------------------------------------------------------------------------
DEBUGLIBPATH = $(BCB_PATH)\lib\debug
RELEASELIBPATH = $(BCB_PATH)\lib\release
USERDEFINES = 
SYSDEFINES = NO_STRICT
INCLUDEPATH = .;include;$(BCB_PATH)\projects;$(BCB_PATH)\include;$(BCB_PATH)\include\vcl
LIBPATH = .;$(BCB_PATH)\projects;$(BCB_PATH)\lib\obj;$(BCB_PATH)\lib;$(BCB_PATH)\lib\Release
WARNINGS= -w-par 

# ---------------------------------------------------------------------------
CFLAG1 = -Od -Vx -Ve -X- -r- -a8 -b- -k -y -v -vi- -c -tW -tWM -n$(BUILD_PREFIX)
IDLCFLAGS = 
PFLAGS = -$YD -$W -$O- -$A8 -v -JPHNE -M
RFLAGS = 
AFLAGS = /mx /w2 /zd
LFLAGS = -aa -Tpe -x -Gn -v
# ---------------------------------------------------------------------------
ALLOBJ = c0w32.obj $(PACKAGES) Memmgr.Lib sysinit.obj $(LINKER_OBJFILES)
ALLRES = $(RESFILES)
ALLLIB = $(LIBFILES) $(LIBRARIES) import32.lib cp32mti.lib
# ---------------------------------------------------------------------------

# ---------------------------------------------------------------------------
# MAKE SECTION
# ---------------------------------------------------------------------------
# This section of the project file is not used by the BCB IDE.  It is for
# the benefit of building from the command-line using the MAKE utility.
# ---------------------------------------------------------------------------

#OBJ files for Make rules:
OBJ_FILES=$(addprefix $(BUILD_PREFIX)/, $(OBJS) )

#OBJ files for linker must have \ in paths hence " " envelop is added:
_LINKER_OBJFILES=$(addprefix build\, $(OBJS) )
LINKER_OBJFILES=$(addprefix ", $(addsuffix ", $(_LINKER_OBJFILES)))


BCC32 ?= $(BCB_BIN)/bcc32
CPP32 ?= $(BCB_BIN)/cpp32
DCC32 ?= $(BCB_BIN)/dcc32
TASM32 ?= $(BCB_BIN)/tasm32
LINKER ?= $(BCB_BIN)/ilink32
BRCC32 ?= $(BCB_BIN)/brcc32
ARGS = $(BCB_BIN)/print_a
GCC = $(MINGW_BIN)/gcc
GCC_FLAGS=-I./include

# ---------------------------------------------------------------------------
$(EXE_PREFIX)/$(EXE_FILE): $(OTHERFILES) $(IDLGENFILES) $(OBJ_FILES) $(RESDEPEN) $(DEFFILE) 
	rm -rf $(EXE_PREFIX)/*
	$(LINKER) $(LFLAGS) "-L$(LIBPATH)" $(ALLOBJ), "$(EXE_PREFIX)\$(EXE_FILE)","$(EXE_PREFIX)\$(MAP_FILE)", $(ALLLIB), $(DEFFILE), $(ALLRES)
	
# ---------------------------------------------------------------------------

# TODO: check hpp generation
$(BUILD_PREFIX)/%.hpp : %.pas 
	$(DCC32) $(PFLAGS) -U$(INCLUDEPATH) -D$(USERDEFINES);$(SYSDEFINES) -O$(INCLUDEPATH) --BCB $< -o$@

# TODO: check compilation of .pas files
$(BUILD_PREFIX)/%.obj : %.pas 
	$(DCC32) $(PFLAGS) -U$(INCLUDEPATH) -D$(USERDEFINES);$(SYSDEFINES) -O$(INCLUDEPATH) --BCB $< 

$(BUILD_PREFIX)/%.obj : %.cpp 
	$(BCC32) $(CFLAG1) $(WARNINGS) "-I$(INCLUDEPATH)" "-D$(USERDEFINES);$(SYSDEFINES)" $< -o$@

$(BUILD_PREFIX)/%.obj : %.c
	$(BCC32) $(CFLAG1) $(WARNINGS) "-I$(INCLUDEPATH)" "-D$(USERDEFINES);$(SYSDEFINES)" $< -o$@

$(BUILD_PREFIX)/%.i : %.c
	$(CPP32) $(CFLAG1) $(WARNINGS) "-I$(INCLUDEPATH)" "-D$(USERDEFINES);$(SYSDEFINES)" $< -o$@

$(BUILD_PREFIX)/%.i : %.cpp
	$(CPP32) -Sd -Sc -Sk $(CFLAG1) $(WARNINGS) "-I$(INCLUDEPATH)" "-D$(USERDEFINES);$(SYSDEFINES)" $< -o$@ 

#TODO check asm files compilation
$(BUILD_PREFIX)/%.obj : %.asm
	$(TASM32) $(AFLAGS) -i$(INCLUDEPATH:;= -i) $(AUSERDEFINES) -d$(SYSDEFINES:;= -d) $<, $@

$(BUILD_PREFIX)/%.res : %.rc
	$(BRCC32) $(RFLAGS) -I$(INCLUDEPATH) -D$(USERDEFINES);$(SYSDEFINES) -fo$@ $<
#NOTE: main .res file is generated by IDE, no .rc file exists for that.


# ---------------------------------------------------------------------------
# Dependencies
DEPS= $(OBJ_FILES:.obj=.d)

deps: $(DEPS)
	echo "Dependencies has been built"
	
$(BUILD_PREFIX)/%.d : %.cpp
	echo -n "$(BUILD_PREFIX)/" > $@.tmp
	export PATH=$(MINGW_BIN) && $(GCC) -MM $(GCC_FLAGS) $< >> $@.tmp
	sed 's/[.]o:/.obj:/g' < $@.tmp >$@
	rm $@.tmp
	

$(BUILD_PREFIX)/%.d : %.c
	$(GCC) -MMD $(GCC_FLAGS) $< > $@

	
clean:
	rm -f $(OBJ_FILES)
	rm -f $(OBJ_FILES:.obj=.i)
	rm -f $(EXE_PREFIX)/*
	rm -f $(PROJECT).tds
	
all: $(EXE_PREFIX)/$(EXE_FILE)



